<?php

namespace Drupal\drupalmoduleupgrader\Converter\FunctionReplacement;

use Pharborist\FunctionCallNode;

abstract class FunctionCallAlter extends FunctionCallModifier {

  /**
   * Alters a function call in-place. This should *not* detach the call from
   * its syntax tree -- for that, use a rewriter.
   *
   * @param \Pharborist\FunctionCallNode $call
   *  The function call to alter.
   */
  abstract public function alter(FunctionCallNode $call);

  /**
   * {@inheritdoc}
   */
  public function convert() {
    foreach ($this->functionCalls as $file => $calls) {
      $calls->each([ $this, 'alter' ]);
    }
  }

}
