<?php

namespace Drupal\drupalmoduleupgrader\Converter\FunctionReplacement;

use Pharborist\FunctionCallNode;

abstract class FunctionCallRewriter extends FunctionCallModifier {

  /**
   * Generates a replacement for a function call.
   *
   * @param \Pharborist\FunctionCallNode $call
   *  The original function call, which will be discarded and completely
   *  replaced by whatever is returned.
   *
   * @return \Pharborist\Node
   */
  abstract public function rewrite(FunctionCallNode $call);

  /**
   * {@inheritdoc}
   */
  public function convert() {
    foreach ($this->functionCalls as $file => $calls) {
      foreach ($calls as $call) {
        $rewritten = $this->rewrite($call);
        $call->replaceWith($rewritten);
      }
    }
  }

}
