<?php

namespace Drupal\drupalmoduleupgrader\Converter\Routing;

use Drupal\drupalmoduleupgrader\Converter\ConverterInterface;

/**
 * Defines a route converter, which converts a Drupal 7 router item to a
 * Drupal 8 Symfony route. These plugins are NOT responsible for converting
 * *links* (including tabs or local actions), only the actual route.
 */
interface RouteConverterInterface extends ConverterInterface {

  /**
   * Gets the route's machine-readable name.
   *
   * @return string
   */
  public function getName();

  /**
   * Builds a Drupal 8 route definition. This should build the route, but
   * NOT actually modify any part of the source module. All that logic is
   * handled by the convert() method. This method should build ONLY the
   * route's *definition*, as it will appear in MODULE.routing.yml.
   *
   * @return \Drupal\drupalmoduleupgrader\Converter\Routing\RouteWrapperInterface
   */
  public function buildRoute();

}
