<?php

/**
 * @file
 * Contains Drupal\drupalmoduleupgrader\Plugin\DMU\Routing\GenericRoute.
 */

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Routing;

use Drupal\drupalmoduleupgrader\Converter\Routing\RouteConverterBase;
use Pharborist\FunctionDeclarationNode;

/**
 * @Converter(
 *  id = "default",
 *  description = @Translation("Converts a menu item to a _content route."),
 *  message = @Translation("Page callback functions must be moved into controller classes."),
 *  change_notice = 2119699
 * )
 */
class GenericRoute extends RouteConverterBase {

  /**
   * {@inheritdoc}
   */
  public function convert() {
    parent::convert();

    if ($this->route['page callback'] instanceof FunctionDeclarationNode) {
      $this->transferToController($this->route['page callback']);
    }
  }

  /**
   * {@inheritdoc}
   */
  public function buildRoute() {
    $route = parent::buildRoute();
    $route->setDefault('_content', $this->getQualifiedMethodName($this->route['page callback']->getName()));

    return $route;
  }

  /**
   * {@inheritdoc}
   */
  protected function getHash() {
    return $this->item['page callback'];
  }

}
