<?php

/**
 * @file
 * Contains Drupal\drupalmoduleupgrader\Plugin\DMU\Routing\NodeViewRoute.
 */

namespace Drupal\drupalmoduleupgrader\Plugin\DMU\Routing;

use Drupal\drupalmoduleupgrader\Converter\Routing\RouteConverterBase;

/**
 * @Converter(
 *  id = "node_view",
 *  description = @Translation("Converts node_view() menu items to routes."),
 *  message = @Translation("node_view() is no longer a valid page callback; it must be an _entity_view default on a route.")
 * )
 */
class NodeViewRoute extends RouteConverterBase {

  /**
   * {@inheritdoc}
   */
  public function convert() {
    parent::convert();

    // @todo: What's the default view mode?
    $item = $this->item;
    $view_mode = isset($item['page arguments'][1]) ? $item['page arguments'][1] : 'default';
    $this->defaults['_entity_view'] = 'node.' . $view_mode;
    $this->save();
  }

}
